<template>
    <v-row justify="center">
        <v-col cols="6">
            <v-card>
                <v-card-title>
                    {{ $t('product_', [$tc('category', 2)]) }}

                    <v-spacer></v-spacer>

                    <v-btn color="primary" @click="addCategory">
                        <v-icon left>mdi-plus</v-icon>
                        <span>{{ $tc('category', 1) }}</span>
                    </v-btn>
                </v-card-title>

                <v-card-text>
                    <v-container class="white pa-5">
                        <ValidationObserver ref="typeObserver" v-slot="{ validate, reset }">
                            <v-row v-for="(category, index) in categories" :key="category.id">

                                <div class="col flex-grow-0 flex-shrink-1 align-self-center action">
                                    <v-btn
                                        small
                                        icon
                                        color="error"
                                        :disabled="category.products_count > 0"
                                        @click="remove(category)"
                                    >
                                        <v-icon>mdi-delete</v-icon>
                                    </v-btn>
                                </div>

                                <v-col class="flex-grow-1 flex-shrink-0">
                                    <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                        <v-text-field
                                            v-model="category.name"
                                            :error-messages="errors"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </ValidationProvider>
                                </v-col>

                                <v-col class="flex-grow-1 flex-shrink-0">
                                    <ValidationProvider v-slot="{ errors }" :name="$t('business_type')" rules="required">
                                        <v-business-type-select
                                            v-model="category.business_type_id"
                                            :errors="errors"
                                            :placeholder="$t('business_type')"
                                            outlined
                                        >
                                        </v-business-type-select>
                                    </ValidationProvider>
                                </v-col>
                            </v-row>
                        </ValidationObserver>
                    </v-container>
                </v-card-text>

                <v-card-actions class="justify-center pa-5">
                    <v-btn
                        class="primary"
                        color="white"
                        large
                        :loading="loading"
                        @click="saveChanges"
                    >
                        <v-icon left>mdi-content-save</v-icon>
                        {{ $t('save') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-col>

        <v-dialog
            v-if="creating"
            v-model="createDialog"
            persistent
            max-width="800"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('create_', [$t('product_', [$tc('category', 1)])]) }}
                </v-card-title>

                <v-card-text>
                    <v-container>
                        <v-row>
                            <v-col>
                                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                                    <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                        <v-text-field
                                            v-model="creating.name"
                                            :error-messages="errors"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </ValidationProvider>
                                </ValidationObserver>
                            </v-col>

                            <v-col>
                                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                                    <ValidationProvider v-slot="{ errors }" :name="$t('business_type')" rules="required">
                                        <v-business-type-select
                                            v-model="creating.business_type_id"
                                            :errors="errors"
                                            :placeholder="$t('business_type')"
                                            outlined
                                        >
                                        </v-business-type-select>
                                    </ValidationProvider>
                                </ValidationObserver>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-card-text>

                <v-card-actions class="justify-center py-5">
                    <v-btn
                        class="primary"
                        color="white"
                        :loading="loading"
                        @click="cancelCreate"
                    >
                        <v-icon left>mdi-cancel</v-icon>
                        {{ $t('cancel') }}
                    </v-btn>

                    <v-btn
                        class="primary"
                        color="white"
                        :loading="loading"
                        @click="createCategory"
                    >
                        <v-icon left>mdi-plus</v-icon>
                        {{ $t('create') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-model="deleteDialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="title primary white--text">
                    {{ $t('delete_', [$t('product_', [$tc('category', 1)])]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('del_desc_1') }}</p>
                    <p>{{ $t('del_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        @click="cancel"
                    >
                        {{ $t('cancel') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="yes"
                    >
                        {{ $t('confirm') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import { mapMutations } from "vuex";
    import VBusinessTypeSelect from "../VBusinessTypeSelect";

    export default {
        name: "Category",
        components: {ValidationObserver, ValidationProvider, VBusinessTypeSelect},

        data: () => ({
            loading: true,
            deleteDialog: false,
            createDialog: false,
            creating: null,
            deleting: null,
            categories: [],
            snackbar: {
                show: false,
                color: null,
                timeout: 6000,
                message: ''
            },
        }),

        mounted() {
            this.fetchCategories()
                .then(data => {
                    this.loading = false;
                    this.categories = data;
                });
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            fetchCategories() {
                return new Promise((resolve, reject) => {
                    axios.get('api/categories/all')
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                });
            },

            remove(category) {
                this.deleting = category;
                this.deleteDialog = true;
            },

            addCategory() {
                this.creating = { name: '' };
                this.createDialog = true;
            },

            cancelCreate() {
                this.creating = null;
                this.createDialog = false;
            },

            createCategory() {
                this.loading = true;

                this.$refs.observer.validate()
                    .then(valid => {
                        if(valid) {
                            axios.post('api/categories', this.creating)
                                .then(({ data }) => {
                                    this.categories.push(data);
                                    this.cancelCreate();

                                    this.success(this.$t('product_action.category.created'));
                                })
                                .catch(({ response }) => {
                                    this.error(response.data.message);
                                })
                                .finally(() => {
                                    this.loading = false;
                                })
                        }
                        else {
                            this.loading = false;
                        }
                    });
            },

            saveChanges() {
                this.loading = true;

                this.$refs.typeObserver.validate()
                    .then(valid => {
                        if(valid) {
                            axios.patch('api/categories', {
                                categories: this.categories
                            })
                                .then(({ data }) => {
                                    this.categories = data;
                                    this.success(this.$t('product_action.category.updated'));
                                })
                                .catch(({ response }) => {
                                    this.error(response.data.message);
                                })
                                .finally(() => {
                                    this.loading = false;
                                })
                        }
                        else {
                            this.loading = false;
                        }
                    });
            },

            cancel() {
                this.deleting = null;
                this.deleteDialog = false;
            },

            yes() {
                this.loading = true;

                axios.delete(`api/categories/${this.deleting.id}`)
                    .then(({ data }) => {
                        const index = this.categories.findIndex(b => b.id === this.deleting.id);
                        this.categories.splice(index, 1);
                        this.cancel();

                        this.success(this.$t('product_action.category.deleted'));
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            }
        }
    }
</script>

<style scoped>
</style>
